---
title: TrackEvent
slug: Web/API/TrackEvent
tags:
  - API
  - Audio
  - HTML DOM
  - Interface
  - Media
  - Reference
  - TrackEvent
  - Video
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>TrackEvent</code></strong> interface, which is part of the HTML DOM specification, is used for events which represent changes to a set of available tracks on an HTML media element; these events are {{event("addtrack")}} and {{event("removetrack")}}.</span> It's important not to confuse <code>TrackEvent</code> with the {{domxref("RTCTrackEvent")}} interface, which is used for tracks which are part of an {{domxref("RTCPeerConnection")}}.</p>

<p>Events based on <code>TrackEvent</code> are always sent to one of the media track list types:</p>

<ul>
 <li><span style="display: none;"> </span>Events involving video tracks are always sent to the {{domxref("VideoTrackList")}} found in {{domxref("HTMLMediaElement.videoTracks")}}</li>
 <li>Events involving audio tracks are always sent to the {{domxref("AudioTrackList")}} specified in {{domxref("HTMLMediaElement.audioTracks")}}</li>
 <li>Events affecting text tracks are sent to the {{domxref("TextTrackList")}} object indicated by {{domxref("HTMLMediaElement.textTracks")}}.</li>
</ul>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("TrackEvent.TrackEvent", "TrackEvent()")}}</dt>
 <dd>Creates and initializes a new <code>TrackEvent</code> object with the event type specified, as well as optional additional properties.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em><code>TrackEvent</code> is based on {{domxref("Event")}}, so properties of <code>Event</code> are also available on <code>TrackEvent</code> objects.</em></p>

<dl>
 <dt>{{domxref("TrackEvent.track", "track")}} {{ReadOnlyInline}}</dt>
 <dd>The DOM track object the event is in reference to. If not <code>null</code>, this is always an object of one of the media track types: {{domxref("AudioTrack")}}, {{domxref("VideoTrack")}}, or {{domxref("TextTrack")}}).</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em><code>TrackEvent</code> has no methods of its own; however, it is based on {{domxref("Event")}}, so it provides the methods available on <code>Event</code> objects.</em></p>

<h2 id="Example">Example</h2>

<p>This example sets up a function, <code>handleTrackEvent()</code>, which is callled for any {{event("addtrack")}} or {{event("removetrack")}} event on the first {{HTMLElement("video")}} element found in the document.</p>

<pre class="brush: js">var videoElem = document.querySelector("video");

videoElem.videoTracks.addEventListener("addtrack", handleTrackEvent, false);
videoElem.videoTracks.addEventListener("removetrack", handleTrackEvent, false);
videoElem.audioTracks.addEventListener("addtrack", handleTrackEvent, false);
videoElem.audioTracks.addEventListener("removetrack", handleTrackEvent, false);
videoElem.textTracks.addEventListener("addtrack", handleTrackEvent, false);
videoElem.textTracks.addEventListener("removetrack", handleTrackEvent, false);

function handleTrackEvent(event) {
  var trackKind;

  if (event.target instanceof(VideoTrackList)) {
    trackKind = "video";
  } else if (event.target instanceof(AudioTrackList)) {
    trackKind = "audio";
  } else if (event.target instanceof(TextTrackList)) {
    trackKind = "text";
  } else {
    trackKind = "unknown";
  }

  switch(event.type) {
    case "addtrack":
      console.log("Added a " + trackKind + " track");
      break;
    case "removetrack":
      console.log("Removed a " + trackKind + " track");
      break;
  }
}
</pre>

<p>The event handler uses the JavaScript <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/instanceof">instanceof</a></code> operator to determine which type of track the event occurred on, then outputs to console a message indicating what kind of track it is and whether it's being added to or removed from the element.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "media.html#the-trackevent-interface", "TrackEvent")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "embedded-content-0.html#trackevent", "TrackEvent")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.TrackEvent")}}</p>
